Debian Bug report logs - #679377
busybox awk segfaults when called from ash and no PATH set (eg initramfs /init)

version graph

Package: busybox; Maintainer for busybox is Debian Install System Team <debian-boot@lists.debian.org>; Source for busybox is src:busybox.

Reported by: Jordi Pujol <jordipujolp@gmail.com>

Date: Thu, 28 Jun 2012 09:18:02 UTC

Severity: important

Tags: confirmed

Found in version busybox/1:1.20.0-4

Fixed in version busybox/1:1.20.0-5

Done: Michael Tokarev <mjt@tls.msk.ru>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#679377; Package busybox. (Thu, 28 Jun 2012 09:18:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jordi Pujol <jordipujolp@gmail.com>:
New Bug report received and forwarded. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Thu, 28 Jun 2012 09:18:09 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jordi Pujol <jordipujolp@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: Segmentation fault when initramfs is booting
Date: Thu, 28 Jun 2012 11:14:23 +0200
Package: busybox
Version: 1:1.20.0-4
Severity: important

the patch "shell-ash-export-HOME.patch" causes a segmentation fault when 
initramfs boots,
I believe that this fault occurs the first time that initramfs looks for some 
executable in the initramfs filesystem,

Also, the latest release of busybox, 1.20.1 is a bit different of that, and 
more upstream stable patches have been added. A new release can be packaged 
containing this changes,

Modifying this, busybox works fine,

http://livenet.selfip.com/ftp/debian/package-
modifications/busybox_1.20.1-1.lnet1.debian.tar.gz

Kind regards,

Jordi Pujol

Live never ending Tale
GNU/Linux Live forever!
http://livenet.selfip.com




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#679377; Package busybox. (Wed, 04 Jul 2012 16:15:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Tokarev <mjt@tls.msk.ru>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Wed, 04 Jul 2012 16:15:08 GMT) Full text and rfc822 format available.

Message #10 received at 679377@bugs.debian.org (full text, mbox):

From: Michael Tokarev <mjt@tls.msk.ru>
To: Jordi Pujol <jordipujolp@gmail.com>
Cc: 679377@bugs.debian.org
Subject: Re: Bug#679377: Segmentation fault when initramfs is booting
Date: Wed, 04 Jul 2012 20:08:30 +0400
tags 679377 + moreinfo
thanks

On 28.06.2012 13:14, Jordi Pujol wrote:
> Package: busybox
> Version: 1:1.20.0-4
> Severity: important
> 
> the patch "shell-ash-export-HOME.patch" causes a segmentation fault when 
> initramfs boots,
> I believe that this fault occurs the first time that initramfs looks for some 
> executable in the initramfs filesystem,

Does whole thing actually work?  Why do you think it is this patch
which causes the SIGSEGV?  The change in this patch is quite, well,
innocent, it does not look like it can be a cause for any such issues.

Can you describe your initramfs/environment a bit?  Maybe give me
access to your initramfs for testing?

> Also, the latest release of busybox, 1.20.1 is a bit different of that, and 

Different of what, exactly?  The version of busybox you're
filing bugreport against is actually 1.20.1, so there are
two questions actually: what is different, and different
between what and what? -- since you're comparing the same
thing with itself.

> more upstream stable patches have been added. A new release can be packaged 
> containing this changes,

The only upstream change not included in debian package is
busybox-1.20.1-mke2fs.patch, which is only relevant for
busybox-static since other variants don't enable mkfs.

> Modifying this, busybox works fine,
> 
> http://livenet.selfip.com/ftp/debian/package-
> modifications/busybox_1.20.1-1.lnet1.debian.tar.gz

Now that's fantastic.  Let's see.

diff -u -p -r debian/patches/series lnet/patches/series
--- 1.20.0-4/patches/series	2012-06-12 22:04:46.000000000 +0400
+++ lnet1/patches/series	2012-06-22 19:15:34.000000000 +0400
@@ -1,6 +1,4 @@
-1.20.1.patch
-
-shell-ash-export-HOME.patch
+#shell-ash-export-HOME.patch
 # we need to get rid of this one:
 #applets-fallback.patch
 version.patch
@@ -11,10 +9,12 @@ u-mount-FreeBSD-support.patch
 swaponoff-FreeBSD-support.patch

 # FTBFS on non-linux
-ps-get-uptime.patch
+#ps-get-uptime.patch

 # upstream stable patches
 busybox-1.20.1-ash.patch
 busybox-1.20.1-ifupdown.patch
 busybox-1.20.1-man.patch
+busybox-1.20.1-mke2fs.patch
+busybox-1.20.1-ps.patch
 busybox-1.20.1-tar.patch

So you reverted all fixes which went into 1.20.1 bugfix
release, you reverted my ps-get-uptime.patch but added
busybox-1.20.1-ps.patch (it has exactly the same content),
added busybox-1.20.1-mke2fs.patch (which is not relevant
for the issue in question), and reverted shell-ash-export-HOME.patch
which looks completely innocent here, without trying to
understand what it does and WHY it is here.

Wherer's the improvement?  This is definitely NOT a way
to do things.

So, I really want to know more about your environment and
the segfault.  I don't see any segfaults here.

Thanks,

/mjt




Added tag(s) moreinfo. Request was from Michael Tokarev <mjt@tls.msk.ru> to control@bugs.debian.org. (Wed, 04 Jul 2012 16:15:13 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#679377; Package busybox. (Thu, 05 Jul 2012 00:36:22 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Stefan Lippers-Hollmann" <s.L-H@gmx.de>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Thu, 05 Jul 2012 00:36:22 GMT) Full text and rfc822 format available.

Message #17 received at 679377@bugs.debian.org (full text, mbox):

From: "Stefan Lippers-Hollmann" <s.L-H@gmx.de>
To: Michael Tokarev <mjt@tls.msk.ru>
Cc: 679377@bugs.debian.org
Subject: Re: Bug#679377: Segmentation fault when initramfs is booting
Date: Thu, 5 Jul 2012 02:32:58 +0200
[Message part 1 (text/plain, inline)]
Hi

On Wednesday 04 July 2012, Michael Tokarev wrote:
[…]
> On 28.06.2012 13:14, Jordi Pujol wrote:
[…] 
> > the patch "shell-ash-export-HOME.patch" causes a segmentation fault when 
> > initramfs boots,
> > I believe that this fault occurs the first time that initramfs looks for some 
> > executable in the initramfs filesystem,
> 
> Does whole thing actually work?  Why do you think it is this patch
> which causes the SIGSEGV?  The change in this patch is quite, well,
> innocent, it does not look like it can be a cause for any such issues.

I'm having trouble with the same problem in a custom (not Debian live)
live boot environment, where busybox awk segfaults with 
shell-ash-export-HOME.patch applied. The code in question is[1]:

FINGERED=$(awk -F: '
	$1 == "drive name" && NF > 1 {
		split($2, node, " ")
		for (n in node) {
			if (!system("test -b /dev/" node[n]))
				cdrom[i++] = "/dev/" node[n]
		}
	}
	END {
		for (c in cdrom)
			print cdrom[c]
	}
' /proc/sys/dev/cdrom/info)

Leading to:

Loading, please wait...
modprobe: module unix not found in modules.dep
mdadm: No arrays found in config file or automatically
Segmentation fault
Waiting for up to 30s for devices to settle...
Segmentation fault
Segmentation fault
Segmentation fault
Segmentation fault
Segmentation fault
Segmentation fault
Segmentation fault
Segmentation fault
Segmentation fault
Segmentation fault
Failed to detect live media
modprobe: module i8042 not found in modules.dep
modprobe: module atkbd not found in modules.dep


BusyBox v1.20.1 (Debian 1:1.20.0-4) built-in shell (ash)
Enter 'help' for a list of built-in commands.

/bin/sh: can't access tty; job control turned off
(initramfs)


Executing the very same awk command from the initramfs shell (busybox 
ash) afterwards succeeds however:

(initramfs) FINGERED=$(awk -F: '
> $1 == "drive name" && NF > 1 {
> split($2, node, " ")
> for (n in node) {
> if (!system("test -b /dev/" node[n]))
> cdrom[i++] = "/dev/" node[n]
> }
> }
> END {
> for (c in cdrom)
> print cdrom[c]
> }
> ' /proc/sys/dev/cdrom/info)
(initramfs) echo $FINGERED
/dev/sr0

Likewise rewriting the /proc/sys/dev/cdrom/info parsing to use 
different busybox applets succeeds as well, while using awk in 
different functions (fll_meminfo() and fll_copy_with_perc()) segfaults 
the same way.

> Can you describe your initramfs/environment a bit?  Maybe give me
> access to your initramfs for testing?

I'll provide a link to a test environment in a (private) follow up 
mail, using this live code. While this particular initramfs hook is 
not packaged in Debian, I expect similar issues to arise with standard
Debian initramfs hooks.

> > Also, the latest release of busybox, 1.20.1 is a bit different of that, and 
> 
> Different of what, exactly?  The version of busybox you're
> filing bugreport against is actually 1.20.1, so there are
> two questions actually: what is different, and different
> between what and what? -- since you're comparing the same
> thing with itself.
[…]

For testing purposes, I've rebuilt busybox (1:1.20.0-4) with only
shell-ash-export-HOME.patch disabled:

--- busybox-1.20.0/debian/patches/series
+++ busybox-1.20.0/debian/patches/series
@@ -1,6 +1,6 @@
 1.20.1.patch
 
-shell-ash-export-HOME.patch
+#shell-ash-export-HOME.patch
 # we need to get rid of this one:
 #applets-fallback.patch
 version.patch

and the segfaults in busybox awk vanished.

Regards
	Stefan Lippers-Hollmann

[1]	http://svn.berlios.de/svnroot/repos/fullstory/fll-live-initramfs/trunk/scripts/fll
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#679377; Package busybox. (Thu, 05 Jul 2012 11:15:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jordi Pujol <jordipujolp@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Thu, 05 Jul 2012 11:15:18 GMT) Full text and rfc822 format available.

Message #22 received at 679377@bugs.debian.org (full text, mbox):

From: Jordi Pujol <jordipujolp@gmail.com>
To: Michael Tokarev <mjt@tls.msk.ru>
Cc: 679377@bugs.debian.org
Subject: Re: Bug#679377: Segmentation fault when initramfs is booting
Date: Thu, 5 Jul 2012 13:12:41 +0200
A Dimecres, 4 de juliol de 2012 18:08:30, Michael Tokarev va escriure:
> tags 679377 + moreinfo
> thanks
> 
> On 28.06.2012 13:14, Jordi Pujol wrote:
> > Package: busybox
> > Version: 1:1.20.0-4
> > Severity: important
> > 
> > the patch "shell-ash-export-HOME.patch" causes a segmentation fault when
> > initramfs boots,
> > I believe that this fault occurs the first time that initramfs looks for
> > some executable in the initramfs filesystem,
> 
> Does whole thing actually work?  Why do you think it is this patch
> which causes the SIGSEGV?  The change in this patch is quite, well,
> innocent, it does not look like it can be a cause for any such issues.
> 
This works now, using the modified version,
There are a few weeks, after the upgrade 
of Busybox, the system not booted; 
automatically it entered in the Busybox shell, and we see "Segmentation 
fault..." in the file /run/initramfs/initramfs.debug
Trying the new version 1.20.1 from upstream, with their stable patches, 
allways boots.
Adding the old patches to that, this little patch makes the boot fail,

I believe that some built-in Busybox commands access to internal memory tables 
that are not initialized yet,
These tables may be initialized with some commands that manage paths or 
directories. (It's supposed, from experiences).

> Can you describe your initramfs/environment a bit?  Maybe give me
> access to your initramfs for testing?
my initramfs is based in Debian Live initramfs, in their mailing-list they 
have been talking about that and it's solved with a workaround. This 
workaround re-creates a directory (mkdir -p) that already exists.

http://lists.debian.org/CAFp4thR1VTaWJxjO1G0A--
N3ww8Mnrf3E=PE0WTYe_zTExcUjg@mail.gmail.com

> 
> > Also, the latest release of busybox, 1.20.1 is a bit different of that,
> > and
> 
> Different of what, exactly?  The version of busybox you're
> filing bugreport against is actually 1.20.1, so there are
> two questions actually: what is different, and different
> between what and what? -- since you're comparing the same
> thing with itself.
Sorry, a detailed look shows that I was magnifying the things, there is only 
one diff,

diff -Naurp ../busybox-1.20.0/shell/ash.c ../busybox-1.20.1-lnet1/shell/ash.c
--- ../busybox-1.20.0/shell/ash.c	2012-07-05 12:11:06.000000000 +0200
+++ ../busybox-1.20.1-lnet1/shell/ash.c	2012-04-22 03:45:24.000000000 +0200
@@ -6846,7 +6846,8 @@ evalvar(char *p, int flags, struct strli
 		patloc = expdest - (char *)stackblock();
 		if (NULL == subevalvar(p, /* varname: */ NULL, patloc, subtype,
 				startloc, varflags,
-				/* quotes: */ flags & (EXP_FULL | EXP_CASE | EXP_REDIR),
+//TODO: | EXP_REDIR too? All other such places do it too
+				/* quotes: */ flags & (EXP_FULL | EXP_CASE),
 				var_str_list)
 		) {
 			int amount = expdest - (

> So, I really want to know more about your environment and
> the segfault.  I don't see any segfaults here.
This Segmentation fault is really difficult to debug, it's supposed that occurs 
depending on the instruccions contained in every script,

Here is a saved log of an execution, using a modified Debian Live initramfs 
that traps all errors,

...
+ maybe_break mount
+ [  = mount ]
+ log_begin_msg Mounting root file system
+ _log_msg Begin: Mounting root file system ... 
+ [ n = y ]
+ printf Begin: Mounting root file system ... 
Begin: Mounting root file system ... + . /scripts/lnet
+ export LANG=C
+ LNET_LIVEPOINT=/lnet
+ mountpoint=/lnet/image
+ LNET_MEDIA_PATH=LneT
+ LNET_LIVEVARS=/etc/lnet.vars
+ LNET_USERNAME=livenet
+ LNET_USERFULLNAME=Live never ending Tale user
+ LNET_HOSTNAME=Live-neT
+ [ -z -qb ]
+ LNET_MODPROBE_OPTIONS=-qb
+ . /scripts/functions
+ set -e
+ trap set +e ; trap - 0 ; panic "Error in ${0}" 0
+ touch /etc/mtab
+ mkdir -p /lnet
+ awk /MemTotal:/{print $2} /proc/meminfo
Segmentation fault...
(next the panic routine is executed...)

All the commands are built-in Busybox commands,

It has been not possible to save a log in Debian Live; in this environment 
after the error the shell was locked or unresponsible,

it seems that everyone has solved this, in a form or other, change the 
severity to normal, if you want.

Thanks,

Jordi Pujol

Live never ending Tale
GNU/Linux Live forever!
http://livenet.selfip.com




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#679377; Package busybox. (Thu, 05 Jul 2012 13:15:34 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Tokarev <mjt@tls.msk.ru>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Thu, 05 Jul 2012 13:15:34 GMT) Full text and rfc822 format available.

Message #27 received at 679377@bugs.debian.org (full text, mbox):

From: Michael Tokarev <mjt@tls.msk.ru>
To: Stefan Lippers-Hollmann <s.L-H@gmx.de>, 679377@bugs.debian.org
Cc: Jordi Pujol <jordipujolp@gmail.com>
Subject: Re: Bug#679377: Segmentation fault when initramfs is booting
Date: Thu, 05 Jul 2012 16:26:50 +0400
On 05.07.2012 04:32, Stefan Lippers-Hollmann wrote:
[]
> I'm having trouble with the same problem in a custom (not Debian live)
> live boot environment, where busybox awk segfaults with 
> shell-ash-export-HOME.patch applied. The code in question is[1]:
> 
> FINGERED=$(awk -F: '
[]
> Executing the very same awk command from the initramfs shell (busybox 
> ash) afterwards succeeds however:

It looks like the problem only happens with awk and only
when it is called as "awk" (not busybox awk and not /bin/awk
after adding a symlink with this name pointing to busybox)
and only when it is called from pid=1.

For example, I did some experiments, and put a simple
awk call in a separate file "/at".  Executing it from
/init does not produce segfault, but sourcing it does
(so it only happens with pid==1).

I can only guess it is due to awk being NOEXEC applet.

This is a problem very difficult to debug.  I'll try
to get something out of this all.

Thank you!

/mjt




Removed tag(s) moreinfo. Request was from Michael Tokarev <mjt@tls.msk.ru> to control@bugs.debian.org. (Thu, 05 Jul 2012 19:15:05 GMT) Full text and rfc822 format available.

Added tag(s) confirmed. Request was from Michael Tokarev <mjt@tls.msk.ru> to control@bugs.debian.org. (Thu, 05 Jul 2012 19:15:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#679377; Package busybox. (Sat, 07 Jul 2012 21:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Tokarev <mjt@tls.msk.ru>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Sat, 07 Jul 2012 21:57:03 GMT) Full text and rfc822 format available.

Message #36 received at 679377@bugs.debian.org (full text, mbox):

From: Michael Tokarev <mjt@tls.msk.ru>
To: Jordi Pujol <jordipujolp@gmail.com>, 679377@bugs.debian.org, Stefan Lippers-Hollmann <s.L-H@gmx.de>
Subject: Re: Bug#679377: Segmentation fault when initramfs is booting
Date: Sun, 08 Jul 2012 01:55:10 +0400
retitle 679377 busybox awk segfaults when called from ash and no PATH set (eg initramfs /init)
tags 679377 + pending
thanks

On 05.07.2012 15:12, Jordi Pujol wrote:
[]
>>> the patch "shell-ash-export-HOME.patch" causes a segmentation fault when
>>> initramfs boots,
>>> I believe that this fault occurs the first time that initramfs looks for
>>> some executable in the initramfs filesystem,

Big thanks to Denys Vlasenko, the issue has been identified.

awk applet, when initializes, converts environment variables
into awk internal variables, and while doing this, it temporary
replaces the equal sign (=) in ther with a null byte (\0).

awk applet is marked as NOEXEC, ie, it is okay to run it directly
from shell just by calling appropriate awk_main() routine, without
executing any external program.

When ash tries to run such applet, it initializes environment
variables first, and calls the applet's main() function.

The patch in question exports PATH variable with its default
value.  But this value is stored in a global CONSTANT variable
(marked as "const").  All other exported variables are
in malloc'ed memory.

Also, when awk is run as a separate command, the kernel sets
environment variables to be completely writable.

So this very case - calling awk applet from ash when no
PATH variable has been set - is the only case when ONE
environment variable - PATH - is not writable.  And when
awk applet initializes and tries to replace "=" with "\0",
it segfaults.

I added a temporary workaround to this patch - making
the default PATH variable to be non-const, ie, writable,
this way awk will be able to write to it.  No other parts
of the code tries to write to it, so it is a safe change.

I can't drop this patch now, since it is too risky change
at this stage in wheezy release.  This rather obscure
case were difficult enough to debug, and I don't want
to introduce another obscure issue in some other component
while wheezy is frozen.

By the way, the same issue can be reproduced much, much
more easily:

 $ env -i /bin/busybox ash -c awk
 Segmentation fault

That was the missing part: no environment variables are
set, including $PATH.

Thanks,

/mjt




Changed Bug title to 'busybox awk segfaults when called from ash and no PATH set (eg initramfs /init)' from 'Segmentation fault when initramfs is booting' Request was from Michael Tokarev <mjt@tls.msk.ru> to control@bugs.debian.org. (Sat, 07 Jul 2012 21:57:05 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Michael Tokarev <mjt@tls.msk.ru> to control@bugs.debian.org. (Sat, 07 Jul 2012 21:57:05 GMT) Full text and rfc822 format available.

Reply sent to Michael Tokarev <mjt@tls.msk.ru>:
You have taken responsibility. (Sat, 07 Jul 2012 22:33:13 GMT) Full text and rfc822 format available.

Notification sent to Jordi Pujol <jordipujolp@gmail.com>:
Bug acknowledged by developer. (Sat, 07 Jul 2012 22:33:13 GMT) Full text and rfc822 format available.

Message #45 received at 679377-close@bugs.debian.org (full text, mbox):

From: Michael Tokarev <mjt@tls.msk.ru>
To: 679377-close@bugs.debian.org
Subject: Bug#679377: fixed in busybox 1:1.20.0-5
Date: Sat, 07 Jul 2012 22:32:26 +0000
Source: busybox
Source-Version: 1:1.20.0-5

We believe that the bug you reported is fixed in the latest version of
busybox, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 679377@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Michael Tokarev <mjt@tls.msk.ru> (supplier of updated busybox package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 08 Jul 2012 01:37:18 +0400
Source: busybox
Binary: busybox busybox-static busybox-udeb busybox-syslogd udhcpc udhcpd
Architecture: source all i386
Version: 1:1.20.0-5
Distribution: unstable
Urgency: low
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Changed-By: Michael Tokarev <mjt@tls.msk.ru>
Description: 
 busybox    - Tiny utilities for small and embedded systems
 busybox-static - Standalone rescue shell with tons of builtin utilities
 busybox-syslogd - Provides syslogd and klogd using busybox
 busybox-udeb - Tiny utilities for the debian-installer (udeb)
 udhcpc     - Provides the busybox DHCP client implementation
 udhcpd     - Provides the busybox DHCP server implementation
Closes: 406114 679377 680342
Changes: 
 busybox (1:1.20.0-5) unstable; urgency=low
 .
   * enable various xargs features for all flavours, to make it work
     as POSIX requires (notable quotes and backslash processing).
     Also enable -0 option, apparently forgotten at the time (it
     complements find -print0 which is enabled).  (Closes: #680342)
   * replace my ps-get-uptime.patch with busybox-1.20.1-ps.patch
     (it is the same patch, just file formatting changed and it
     is now obvios the patch is applied upstream)
   * added another upstream bugfix patch, busybox-1.20.1-mke2fs.patch,
     to fix mkfs.ext2 breakage.  It is only used in static flavour in
     debian, but producing broken filesystem isn't an option there too.
   * busybox-1.20.1-1.20.2.patch -- change version to 1.20.2.  This is
     the only remaining change to upstream 1.20.2 stable release.
   * enable ping applet for udeb build, +613 bytes on i386.  (Closes: #406114)
   * update shell-ash-export-HOME.patch - DEP-3 headers and a long
     description.  This patch now removes "const" modifier from the
     default PATH variable definition, making it writable.  Full
     description is within the patch comments. (Closes: #679377)
Checksums-Sha1: 
 7ad764312fe172283d486fbb362e8491cf2b7578 1610 busybox_1.20.0-5.dsc
 b2f178c67563c865c28d3a0959728f537a5c8d28 54747 busybox_1.20.0-5.debian.tar.gz
 0272f02a0e201396caab2780ad1d01f18755219c 19826 busybox-syslogd_1.20.0-5_all.deb
 0bd53686f64592a96ea04671c93989bc322c1455 875982 busybox-static_1.20.0-5_i386.deb
 510762af8389d986bcba4fcc160e887c0fc2ecc9 439928 busybox_1.20.0-5_i386.deb
 a23c4b6852b818ca667932258c6263acccf67e8a 17492 udhcpc_1.20.0-5_i386.deb
 4ca0ee464e5a36974c72f10ad51aa1052a6cfcab 20800 udhcpd_1.20.0-5_i386.deb
 aa8b3221b7e8820dc40cdee5a5a42c114cc46c3b 176440 busybox-udeb_1.20.0-5_i386.udeb
Checksums-Sha256: 
 9f8b2c3905beeddab504e1e76a3b1c82108dbc4a376662974fee63a75343b96d 1610 busybox_1.20.0-5.dsc
 9a58ca2cd0ded3aa0556fff39eca291957d6a6db2c6cd960d9f6c0fe96dce1c7 54747 busybox_1.20.0-5.debian.tar.gz
 19f10f19ff759ad2486f9268f31b473d002e7803c90133db2e145b932e78244d 19826 busybox-syslogd_1.20.0-5_all.deb
 d2d787a860e8ef37a97a6b165e22d95ddd297d2e6e2d870d7b649b41c94e4435 875982 busybox-static_1.20.0-5_i386.deb
 4ad9c8f7778e57f5b2360e5a36095815a8baa7eafff989682ed5c145aadaf443 439928 busybox_1.20.0-5_i386.deb
 8a72302efc7cfa2b03d736fefe2b1f20f9de72df7f945ca36aab2762a25de786 17492 udhcpc_1.20.0-5_i386.deb
 9ae844ad38da26b8737ac3a2c062ad16a7a647608a5e903747c4bef3120294e6 20800 udhcpd_1.20.0-5_i386.deb
 4c9a99dfb7b2d85c3acbb64f3002ff84e91846f90e941a52951dab93a563e0cb 176440 busybox-udeb_1.20.0-5_i386.udeb
Files: 
 47ca5db6aded2dd9b57f07cccf5e00fc 1610 utils optional busybox_1.20.0-5.dsc
 2b0a9761ab46eb1fe4cccd908d999f90 54747 utils optional busybox_1.20.0-5.debian.tar.gz
 160b6ee1c2ec211e5e7c9a5da3693584 19826 utils optional busybox-syslogd_1.20.0-5_all.deb
 f5bf423727e645859d5e8c48f5830303 875982 shells extra busybox-static_1.20.0-5_i386.deb
 1895f199f303925a91e7d28222abd2c0 439928 utils optional busybox_1.20.0-5_i386.deb
 e3c7c799f3e3f520293cd03f86f9f2e9 17492 net optional udhcpc_1.20.0-5_i386.deb
 20a508d75a2976a7f5bed3db05d8f075 20800 net optional udhcpd_1.20.0-5_i386.deb
 c2ff1af0141069901c1e732c68f27465 176440 debian-installer extra busybox-udeb_1.20.0-5_i386.udeb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iJwEAQECAAYFAk/4sfsACgkQUlPFrXTwyDi1HAQAn6q2iGtAj0td4vHga81XCx/e
a5xuW7rAzkjY/ntsDkEWB6hcRgFgBBrxzQoIxwaBmugjHodkWZx5z1ubbTNAp2La
oAf+a2lreMrXnz5DiHmRP0utPsApF0HF4EAVpuMmcLOfIaud/pL6cY0taTjf2aug
SUnNIXExArPPuHWLWSQ=
=YLQg
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Install System Team <debian-boot@lists.debian.org>:
Bug#679377; Package busybox. (Mon, 09 Jul 2012 00:39:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Stefan Lippers-Hollmann" <s.L-H@gmx.de>:
Extra info received and forwarded to list. Copy sent to Debian Install System Team <debian-boot@lists.debian.org>. (Mon, 09 Jul 2012 00:39:04 GMT) Full text and rfc822 format available.

Message #50 received at 679377@bugs.debian.org (full text, mbox):

From: "Stefan Lippers-Hollmann" <s.L-H@gmx.de>
To: 679377@bugs.debian.org
Subject: Re: Bug#679377: Segmentation fault when initramfs is booting
Date: Mon, 9 Jul 2012 02:35:06 +0200
Hi

On Saturday 07 July 2012, Michael Tokarev wrote:
[…]
> On 05.07.2012 15:12, Jordi Pujol wrote:
> []
> >>> the patch "shell-ash-export-HOME.patch" causes a segmentation fault when
> >>> initramfs boots,
> >>> I believe that this fault occurs the first time that initramfs looks for
> >>> some executable in the initramfs filesystem,
> 
> Big thanks to Denys Vlasenko, the issue has been identified.
[…]
> I added a temporary workaround to this patch - making
> the default PATH variable to be non-const, ie, writable,
> this way awk will be able to write to it.  No other parts
> of the code tries to write to it, so it is a safe change.
[…]

Thanks a lot for your and Denys Vlasenko's efforts, this workaround in 
busybox 1:1.20.0-5 works fine for my use case :)

Regards
	Stefan Lippers-Hollmann




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 08 Aug 2012 07:33:26 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 13:03:37 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.